VERSION 5.00
Begin VB.Form MGCP 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "MouseGlove Control Panel"
   ClientHeight    =   6780
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4110
   Icon            =   "MGCP.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6780
   ScaleWidth      =   4110
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton resetall 
      Caption         =   "Reset All"
      Height          =   375
      Left            =   1320
      TabIndex        =   14
      Top             =   3240
      Width           =   1335
   End
   Begin VB.CommandButton CenterPoint 
      Caption         =   "Set Neutral Center "
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   2760
      Width           =   1455
   End
   Begin VB.HScrollBar Offtime 
      Height          =   255
      Left            =   240
      Max             =   100
      Min             =   5
      TabIndex        =   5
      Top             =   6120
      Value           =   5
      Width           =   3495
   End
   Begin VB.CommandButton TermDrv 
      Caption         =   "Terminate Driver"
      Height          =   255
      Left            =   2280
      TabIndex        =   4
      Top             =   1200
      Width           =   1335
   End
   Begin VB.ComboBox Port 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   1080
      Width           =   1455
   End
   Begin VB.CommandButton Toggle 
      Caption         =   "Toggle Control"
      Height          =   255
      Left            =   2280
      TabIndex        =   2
      Top             =   2760
      Width           =   1335
   End
   Begin VB.HScrollBar YSense 
      Height          =   255
      Left            =   240
      Max             =   100
      Min             =   10
      TabIndex        =   1
      Top             =   4920
      Value           =   50
      Width           =   3495
   End
   Begin VB.HScrollBar XSense 
      Height          =   255
      Left            =   240
      Max             =   100
      Min             =   10
      TabIndex        =   0
      Top             =   4080
      Value           =   50
      Width           =   3495
   End
   Begin VB.Label X 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "X-Axis : Sets left right sensitivity."
      Height          =   735
      Left            =   120
      TabIndex        =   13
      Top             =   3720
      Width           =   3855
   End
   Begin VB.Label Label7 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Y-Axis : Sets up down sensitivity."
      Height          =   735
      Left            =   120
      TabIndex        =   12
      Top             =   4560
      Width           =   3855
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Off Time Delay : Sets Time required to shutdown driver by pressing left and right buttons simultaneously"
      Height          =   1095
      Left            =   120
      TabIndex        =   11
      Top             =   5400
      Width           =   3855
   End
   Begin VB.Label Label6 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This button can be used to turn off Glove Mouse cursor control while adjusting settings."
      Height          =   1455
      Left            =   2040
      TabIndex        =   10
      Top             =   1680
      Width           =   1935
   End
   Begin VB.Label Label5 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This button sets the rest position of the glove, where no mouse motion is generated."
      Height          =   1455
      Left            =   120
      TabIndex        =   9
      Top             =   1680
      Width           =   1815
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Use this button to shutdown driver. Control Panel will also close since it is not longer connected to a driver."
      Height          =   1455
      Left            =   2040
      TabIndex        =   8
      Top             =   120
      Width           =   1935
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Restart Driver for new  Comm Port Settings to take effect"
      Height          =   1455
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   1815
   End
End
Attribute VB_Name = "MGCP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'========================================================
'MX2125 Mouse Driver Control Panel - by Rob Tauler (TechnoRobbo) 2010
'
'   Use  Mouse Glove Control Panel to change settings
'========================================================

Private Enum CommType
    CT_Quit = 0
    CT_Setx = 1
    CT_SetY = 2
    CT_SetZero = 3
    CT_SetPort = 4
    CT_SetTimeout = 5
    CT_Toggle = 6
    CT_Reset = 7
    
End Enum

Const WM_PASTE = &H302

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Dim WinWnd As Long, Restart As Boolean

Private Sub CenterPoint_Click()
If WinWnd > 0 Then
    SendMessage WinWnd, WM_PASTE, CT_SetZero, 0
End If
End Sub

Private Sub Form_Load()
Dim i As Integer, xport As Integer, X As Object
Restart = True
xport = Val(GetSetting("MouseGlove", "Settings", "Port", "1"))

For i = 1 To 255
    If COMAvailable(i) Or xport = i Then
        Port.AddItem "COM" & Trim(Str(i))
        Port.ItemData(Port.NewIndex) = i
    End If
Next

For i = 0 To Port.ListCount - 1
    If Port.ItemData(i) = xport Then Port.ListIndex = i
Next

XSense = Val(GetSetting("MouseGlove", "Settings", "XSense", "25"))
If XSense = 0 Then XSense = 100
If XSense < 50 Then XSense = 50
If XSense > 200 Then XSense = 200

YSense = Val(GetSetting("MouseGlove", "Settings", "YSense", "25"))
If YSense = 0 Then YSense = 100
If YSense < 50 Then YSense = 50
If YSense > 200 Then YSense = 200

Offtime = Val(GetSetting("MouseGlove", "Settings", "OffTime", "10"))
If Offtime = 0 Then Offtime = 10
If Offtime < 5 Then Offtime = 5
If Offtime > 100 Then Offtime = 100

WinWnd = FindWindow(vbNullString, "MouseGlove")

If WinWnd = 0 Then
    MsgBox "No Driver Active" & vbNewLine & "You will only be able to assign a port"
    For Each X In Me.Controls
        If Left(X.Name, 1) <> "L" And Left(X.Name, 1) <> "P" Then
            X.Enabled = False
        End If
    Next
End If
Restart = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
End
End Sub


Private Sub Offtime_Change()
Dim X As Long
If Restart Then Exit Sub
X = Offtime
If WinWnd > 0 Then
    SendMessage WinWnd, WM_PASTE, CT_SetTimeout, X
End If
End Sub



Private Sub Port_Click()
Dim X As Long
If Restart Then Exit Sub
X = Port.ItemData(Port.ListIndex)
If WinWnd > 0 Then
    SendMessage WinWnd, WM_PASTE, CT_SetPort, X
Else
    SaveSetting "MouseGlove", "Settings", "Port", Port.ItemData(Port.ListIndex)
End If
End Sub

Private Sub resetall_Click()
If MsgBox("Are You Sure Y/N?", vbYesNo, "Reset Defaults") = vbYes Then
    If WinWnd > 0 Then
        SendMessage WinWnd, WM_PASTE, CT_Reset, 0
    End If
    XSense = 25
    YSense = 25
    Offtime = 10
End If
End Sub

Private Sub TermDrv_Click()
If MsgBox("Are You Sure Y/N?", vbYesNo, "Shutdown Mouse Glove") = vbYes Then
    If WinWnd > 0 Then
        SendMessage WinWnd, WM_PASTE, CT_Quit, 0
    End If
    Unload Me
End If
End Sub


Private Sub YSense_Change()
Dim X As Long
If Restart Then Exit Sub
X = YSense
If WinWnd > 0 Then
    SendMessage WinWnd, WM_PASTE, CT_SetY, X
End If
End Sub
Private Sub xSense_Change()
Dim X As Long
If Restart Then Exit Sub
X = XSense
If WinWnd > 0 Then
    SendMessage WinWnd, WM_PASTE, CT_Setx, X
End If
End Sub
Private Sub Toggle_Click()

If WinWnd > 0 Then
    SendMessage WinWnd, WM_PASTE, CT_Toggle, 0
End If
End Sub
Private Function COMAvailable(COMNum As Integer) As Boolean
    Dim hCOM As Long
    Dim ret As Long
    Dim sec As SECURITY_ATTRIBUTES

    'try to open the COM port
    hCOM = CreateFile("COM" & COMNum & "", 0, FILE_SHARE_READ + FILE_SHARE_WRITE, sec, OPEN_EXISTING, _
        FILE_ATTRIBUTE_NORMAL, 0)
    If hCOM = -1 Then
        COMAvailable = False
    Else
        COMAvailable = True
        'close the COM port
        ret = CloseHandle(hCOM)
    End If
End Function

